PROCEDURE INSTRUCT;

  PROCEDURE SHOWCHAR (cc : char);
    var c : byte;
    begin
      c := ord(cc);
      if c in [0..31] then write ('ctrl-',chr(c+ord('@'))) else
        if c = 32 then write ('<spc>') else
          if cc in ['@'..'~'] then write (chr(c)) else
            if c = 127 then write ('<del>') else write (c);
    end;

  BEGIN
    writeln (tab,' MODEM07 is a small remote communications program');
    writeln (tab,' When started it acts simply as dumb terminal.');
    writeln (tab,' The following commands are available : ');
    writeln;
    showchar(capture);
    writeln (tab,' Toggles next capture. Initially inactive. When acting as a terminal');
    writeln (tab,' all text received will be saved in a buffer. The buffer may be saved');
    writeln (tab,' on a disk with the "keep" command below.');
    showchar(keep);
    writeln (tab,' Keep. Lest you save captured text in a disk file. You will be asked');
    writeln (tab,' to name the file in which the text will be saved. The text buffer will');
    writeln (tab,' be cleared if the text is saved successfully.');
    showchar(receive);
    writeln (tab,' Receive a file in Ward Christensen (xmodem) protocol. You will be');
    writeln (tab,' asked for the name of the file to write into');
    showchar(send);
    writeln (tab,' Send a file in Ward Christensen (xmodem) protocol.');
    showchar(view);
    writeln (tab,' Toggle data viewing. Initially inactive.');
    writeln (tab,' Data transmitted will be displayed in ascii or hex.');
    showchar(literal);
    writeln (tab,' Send literal character. A character typed after this character will');
    writeln (tab,' be sent as is. In this way, characters that represent commands may');
    writeln (tab,' be sent without being interpreted as a command.');
    showchar(quit);
    writeln (tab,' Quit. Exit program.');
    writeln;
  END;

G>
being interpreted as a command.');
    showchar(quit);
    writeln (tab,' Quit. Exit program.');
    writeln;
  END;