PROCEDURE READFILE (xfn : fntype);
  var
    sectnum, sectcurr, sectcomp, checksum, fch, xc : byte;
    errors, j, bufptr, fs : integer;
    errorflag : boolean;

  begin
    showrecv := false;
    showtrans := false;
    if viewflag then showrecv := true;
    assign (xmodemfile,xfn);
{$I-}
    rewrite (xmodemfile);
{$I+}
    if ioresult <> 0 then writeln ('Can not create file : ',xfn) else
    begin
      writeln ('Receiving file : ',xfn);
      init_modem;
      bufptr := 0;
      sectnum := 0;
      errors := 0;
      sendchar(nak);
      repeat
        errorflag := false;
        repeat
          fch := readchar(5);
        until (fch = can) or (fch = eot) or (fch = soh) or timeout;

        if timeout then
        begin
          errorflag := true;
          writeln ('Time-out error.');
        end;

        if fch = soh then
        begin
          sectcurr := readchar(1);
          sectcomp := readchar(1);
          if (sectcurr + sectcomp) = $FF then
          begin
            if sectcurr = ((sectnum + 1) and $FF) then
            begin
              checksum := 0;
              if viewmode in ['A','a'] then asciiflag := true;
              for j := bufptr to bufptr + secsiz -1 do
              begin
                xmbuff[j] := readchar(1);
                checksum := checksum + xmbuff[j];
              end;
              asciiflag := false;
              if checksum = readchar(1) then
              begin
                errors := 0;
                sectnum := sectnum + 1;
                bufptr := bufptr + secsiz;
                if (sectnum mod bufsecs) = 0 then
                begin
                  bufptr := 0;
                  blockwrite(xmodemfile,xmbuff[0],bufsecs);
                  repeat xc := readchar(1) until timeout;
                end;
                if showrecv = false then
                begin
                  if (sectnum - 1) mod dots = 0 then
                  write (cr,lf,sectnum : 4,'.') else write ('.');
                end;
                sendchar(ack);
              end
              else
              begin
                write ('Checksum error, expected ');
                hexwrite (checksum);
                writeln (' checksum.');
                errorflag := true;
              end
            end
            else
            begin
              if sectcurr = (sectnum and $FF) then
              begin
                writeln ('Receiving duplicate sector ',sectnum);
                repeat xc := readchar(1) until timeout;
                sendchar(ack);
              end
              else
              begin
                writeln ('Synchronization error.');
                errorflag := true;
              end;
            end;
          end
          else
          begin
            writeln ('Sector number error.');
            errorflag := true;
          end;
        end;

        if errorflag then
        begin
          errors := errors + 1;
          writeln (errors : 3,' errors.');
          repeat xc := readchar(1) until timeout;
          sendchar(nak);
        end;

      until (fch = eot) or (fch = can) or (errors = errormax);

      if (fch = eot) and (errors < errormax) then
      begin
        sendchar(ack);
        blockwrite(xmodemfile,xmbuff[0],sectnum mod bufsecs);
        close(xmodemfile);
        writeln (cr,lf,'Transfer complete.');
      end
      else writeln (cr,lf,'Aborted.');

      if fch = can then writeln (cr,lf,'Cancelled.');

    end;
  end;
     end
      else writeln (cr,lf,'Aborted.');

      if fch = can then writeln (cr,lf,'Cancelled.');

