PROCEDURE SENDFILE (xfn : fntype);
  var
    sectnum, sectors, checksum : byte;
    attempts, j, bufptr, fs : integer;
    rcc : char;

  begin
    showrecv := false;
    showtrans := false;
    if viewflag then showtrans := true;
    assign (xmodemfile,xfn);
{$I-}
    reset (xmodemfile);
{$I+}
    if ioresult <> 0 then writeln ('Can not open file : ',xfn) else
    begin
      writeln ('Sending file : ',xfn);
      fs := filesize(xmodemfile);
      writeln (fs : 4,' sectors to send.');
      sectnum := 1;
      init_modem;
      while fs > 0 do
      begin
        sectors := fs mod secsiz;
        fs := fs - sectors;
        blockread (xmodemfile,xmbuff[0],sectors);
        bufptr := 0;
        repeat until (readchar(60) = nak) or timeout;
        if not timeout then
        begin
          repeat
            attempts := 0;
            repeat
              if showtrans then writeln else
              begin
                if ((sectnum-1) mod dots) = 0 then
                write (cr,lf,sectnum:4,'.') else write ('.');
              end;
              sendchar(soh);
              sendchar(sectnum);
              sendchar(not sectnum);
              checksum := 0;
              if viewmode in ['A','a'] then asciiflag := true;
              for j := bufptr to bufptr+secsiz-1 do
              begin
                sendchar(xmbuff[j]);
                checksum := checksum + xmbuff[j];
              end;
              asciiflag := false;
              sendchar(checksum);
              purge_modem;
              attempts := attempts + 1;
            until (readchar(10) = ack) or (attempts = retrymax) or timeout;
            bufptr := bufptr + secsiz;
            sectnum := sectnum + 1;
            sectors := sectors - 1;
          until (sectors = 0) or (attempts = retrymax) or timeout;
        end;

        if (attempts = retrymax) or timeout then
        begin
          if timeout then
            writeln (cr,lf,'Time-out occurred, aborting.',bell)
          else
            writeln (cr,lf,'No acknowledgment of sector, aborting.',bell)
        end
        else
        begin
          attempts := 0;
          repeat
            sendchar(eot);
            purge_modem;
            attempts := attempts + 1;
          until (readchar(10) = ack) or (attempts = retrymax) or timeout;

          if attempts = retrymax then
            writeln (cr,lf,'No acknowledgment of end-of-file, aborting.',bell) else
            writeln (cr,lf,'Transfer complete.');
        end;
        close(xmodemfile);
      end;
    end;
  end;


            writeln (cr,lf,'Transfer complete.');